/**
  ******************************************************************************
  * @file    Project/STM32F10x_StdPeriph_Template/main.c 
  * @author  MCD Application Team
  * @version V3.5.0
  * @date    08-April-2011
  * @brief   Main program body
  ******************************************************************************
  * @attention
  *
  * THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
  * WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE
  * TIME. AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY
  * DIRECT, INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
  * FROM THE CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE
  * CODING INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
  *
  * <h2><center>&copy; COPYRIGHT 2011 STMicroelectronics</center></h2>
  ******************************************************************************
  */  

/* Includes ------------------------------------------------------------------*/
#include "led.h"
#include "beep.h"
#include "delay.h"
#include "key.h"
#include "sys.h"
#include "lcd1.h"
#include "usart.h"	 
#include "24cxx.h"
#include "touch.h"
#include "includes.h" 	 
#include "gui.h"
#include "app_cfg.h"
#include "GUIDEMO.h"

/////////////////////////UCOSIIջ///////////////////////////////////
OS_EVENT* NMEA_MBOX;

extern void GUIDEMO_main(void);		
extern void MainTaskForTouchSample(void);
/*
*********************************************************************************************************
*                                       LOCAL GLOBAL VARIABLES
*********************************************************************************************************
*/

static  OS_STK App_TaskStartStk[APP_TASK_START_STK_SIZE];
static  OS_STK AppTaskUserIFStk[APP_TASK_USER_IF_STK_SIZE];
static  OS_STK AppTaskKbdStk[APP_TASK_KBD_STK_SIZE];


/*
*********************************************************************************************************
*                                      LOCAL FUNCTION PROTOTYPES
*********************************************************************************************************
*/

static  void App_TaskCreate(void);

static  void App_TaskStart(void* p_arg);
static  void  AppTaskUserIF (void *p_arg);

static  void AppTaskKbd(void* p_arg);

void USART_OUT(USART_TypeDef* USARTx, uint8_t *Data,uint16_t Len);

 extern void MainTaskForCalibrate(void);
/****************************************************************************
*     ƣint main(void)
*     ܣ
* ڲ
* ڲ
* ˵    
* ÷ 
****************************************************************************/
int main(void)
{
   u8 os_err; 
   /* ֹж */
 //  CPU_IntDis();
	  delay_init();
    LED_Init();
	uart_init(9600);
   //TP_Init();
   /* ucosII ʼ */
   OSInit(); 
	
  
   /* Ӳƽ̨ʼ */
  // BSP_Init();                               
   
   // ȼ  һ;ΪԺʹͳ
   os_err = OSTaskCreate((void (*) (void *)) App_TaskStart,               		    //ָָ
                          (void *) 0,												//ʼִʱݸĲָ
               		     (OS_STK *) &App_TaskStartStk[APP_TASK_START_STK_SIZE - 1],	//Ķջջָ   Ӷµݼ
                         (INT8U) APP_TASK_START_PRIO);								//ȼ
             
   OSTimeSet(0);			 //ucosIIĽļ0    ļ0-4294967295  
   OSStart();                //ucosIIں   
   return (0);
}




/****************************************************************************
*     ƣstatic  void App_TaskStart(void* p_arg)
*     ܣʼ
* ڲ
* ڲ
* ˵    
* ÷ 
****************************************************************************/
static  void App_TaskStart(void* p_arg)
{
 
  (void) p_arg;
   //ʼucosIIʱӽ
  // OS_CPU_SysTickInit();
                               
   //ʹucos ͳ
#if (OS_TASK_STAT_EN > 0)
   
   OSStatInit();                //----ͳʼ                                 
#endif

   App_TaskCreate();			//

   while (1)
   {  
      LED0=1;		      	  
	  OSTimeDlyHMSM(0, 0, 0, 200);

	  LED0=0;
	  OSTimeDlyHMSM(0, 0, 0, 200);
   }
}

/****************************************************************************
*     ƣstatic  void App_TaskCreate(void)
*     ܣĺ
* ڲ
* ڲ
* ˵    
* ÷ 
****************************************************************************/
static  void App_TaskCreate(void)
{
  
   NMEA_MBOX=OSSemCreate(1);		                                           //NMEAָź
   /*  û */
   OSTaskCreateExt(AppTaskUserIF,											   //ָָ
   					(void *)0,												   //ʼִʱݸĲָ
   					(OS_STK *)&AppTaskUserIFStk[APP_TASK_USER_IF_STK_SIZE-1],  //Ķջջָ   Ӷµݼ
					APP_TASK_USER_IF_PRIO,									   //ȼ
					APP_TASK_USER_IF_PRIO,									   //ԤԺ汾ʶа汾ͬȼ
					(OS_STK *)&AppTaskUserIFStk[0],							   //ָջջ׵ָ룬ڶջļ
                    APP_TASK_USER_IF_STK_SIZE,									//ָջڶջļ
                    (void *)0,													//ָûӵָ룬չƿ
                    OS_TASK_OPT_STK_CHK|OS_TASK_OPT_STK_CLR);					//ѡָǷջ飬Ƿ񽫶ջ0,ǷҪ
					                                                            //иȵȡ
                    
   /*    */
   OSTaskCreateExt(AppTaskKbd,
   					(void *)0,
					(OS_STK *)&AppTaskKbdStk[APP_TASK_KBD_STK_SIZE-1],
					APP_TASK_KBD_PRIO,
					APP_TASK_KBD_PRIO,
					(OS_STK *)&AppTaskKbdStk[0],
                    APP_TASK_KBD_STK_SIZE,
                    (void *)0,
                    OS_TASK_OPT_STK_CHK|OS_TASK_OPT_STK_CLR);	
}

/****************************************************************************
*     ƣstatic  void  AppTaskUserIF (void *p_arg)
*     ܣû
* ڲ
* ڲ
* ˵    
* ÷ 
****************************************************************************/
static  void  AppTaskUserIF (void *p_arg)
{											   
 (void)p_arg;								    
  GUI_Init();	                             //emWINʼ 
  while(1) 
  {	
  	 WM_SetCreateFlags(WM_CF_MEMDEV);
     GUIDEMO_Main();						 //
	//	TP_Init();
		//	MainTaskForCalibrate();
		 
	  //	MainTaskForTouchSample();
  }
}
/****************************************************************************
*     ƣstatic  void  AppTaskKbd (void *p_arg)
*     ܣȡ
* ڲ
* ڲ
* ˵    
* ÷ 
****************************************************************************/
static  void  AppTaskKbd (void *p_arg)
{
  (void)p_arg;   
   while(1) 
   { 
   	  /* ʱ10msȡһδ	*/
      OSTimeDlyHMSM(0,0,0,10); 	               
	  GUI_TOUCH_Exec();    
   }
}

// void GUI_TOUCH_Exec()
// {
// 	TP_Scan(0);
// }
/******************* (C) COPYRIGHT 2011 STMicroelectronics *****END OF FILE****/
